/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainPackage.java,v 1.3 2008/04/13 20:29:19 urs Exp $
 */
package de.urszeidler.eclipse.callchain;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.urszeidler.eclipse.callchain.CallchainFactory
 * @model kind="package"
 * @generated
 */
public interface CallchainPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "callchain";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://urszeidler.de/callchain/2008/flowmodel";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "transformFlow";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	CallchainPackage eINSTANCE = de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl.init();

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.Documentable <em>Documentable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.Documentable
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getDocumentable()
	 * @generated
	 */
	int DOCUMENTABLE = 13;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENTABLE__COMMENTS = 0;

	/**
	 * The number of structural features of the '<em>Documentable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENTABLE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.ArtifactImpl <em>Artifact</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.ArtifactImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getArtifact()
	 * @generated
	 */
	int ARTIFACT = 8;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__COMMENTS = DOCUMENTABLE__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__NAME = DOCUMENTABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__URI = DOCUMENTABLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Artifact</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_FEATURE_COUNT = DOCUMENTABLE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.ModelImpl <em>Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.ModelImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getModel()
	 * @generated
	 */
	int MODEL = 0;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__COMMENTS = ARTIFACT__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__NAME = ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__URI = ARTIFACT__URI;

	/**
	 * The feature id for the '<em><b>Mm</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__MM = ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Is Temporary</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__IS_TEMPORARY = ARTIFACT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_FEATURE_COUNT = ARTIFACT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.AtlResImpl <em>Atl Res</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.AtlResImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAtlRes()
	 * @generated
	 */
	int ATL_RES = 1;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_RES__COMMENTS = ARTIFACT__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_RES__NAME = ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_RES__URI = ARTIFACT__URI;

	/**
	 * The feature id for the '<em><b>Superimpose</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_RES__SUPERIMPOSE = ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Atl Res</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_RES_FEATURE_COUNT = ARTIFACT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.CallImpl <em>Call</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.CallImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCall()
	 * @generated
	 */
	int CALL = 2;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__COMMENTS = DOCUMENTABLE__COMMENTS;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__NEXT = DOCUMENTABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__NAME = DOCUMENTABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>In</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__IN = DOCUMENTABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Out</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__OUT = DOCUMENTABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Res</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__RES = DOCUMENTABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Libarys</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__LIBARYS = DOCUMENTABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Allow Inter Model References</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__ALLOW_INTER_MODEL_REFERENCES = DOCUMENTABLE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Continue After Errors</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__CONTINUE_AFTER_ERRORS = DOCUMENTABLE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Artifact</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__ARTIFACT = DOCUMENTABLE_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Enviorment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__ENVIORMENT = DOCUMENTABLE_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Show Summary</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__SHOW_SUMMARY = DOCUMENTABLE_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Print Execution Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__PRINT_EXECUTION_TIME = DOCUMENTABLE_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Disable Attribute Helper Cache</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__DISABLE_ATTRIBUTE_HELPER_CACHE = DOCUMENTABLE_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>Profile</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__PROFILE = DOCUMENTABLE_FEATURE_COUNT + 13;

	/**
	 * The number of structural features of the '<em>Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_FEATURE_COUNT = DOCUMENTABLE_FEATURE_COUNT + 14;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.MMImpl <em>MM</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.MMImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMM()
	 * @generated
	 */
	int MM = 3;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM__COMMENTS = ARTIFACT__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM__NAME = ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM__URI = ARTIFACT__URI;

	/**
	 * The feature id for the '<em><b>Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM__HANDLER = ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MM</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_FEATURE_COUNT = ARTIFACT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.CallsImpl <em>Calls</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.CallsImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCalls()
	 * @generated
	 */
	int CALLS = 4;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__COMMENTS = DOCUMENTABLE__COMMENTS;

	/**
	 * The feature id for the '<em><b>Call</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__CALL = DOCUMENTABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Generators</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__GENERATORS = DOCUMENTABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Artifacts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__ARTIFACTS = DOCUMENTABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Default Lib</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__DEFAULT_LIB = DOCUMENTABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Default Super Imposed</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__DEFAULT_SUPER_IMPOSED = DOCUMENTABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Start Points</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__START_POINTS = DOCUMENTABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Default Start Point</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__DEFAULT_START_POINT = DOCUMENTABLE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Log Default</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__LOG_DEFAULT = DOCUMENTABLE_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>Calls</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS_FEATURE_COUNT = DOCUMENTABLE_FEATURE_COUNT + 8;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.AtlLibaryImpl <em>Atl Libary</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.AtlLibaryImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAtlLibary()
	 * @generated
	 */
	int ATL_LIBARY = 5;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_LIBARY__COMMENTS = ARTIFACT__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_LIBARY__NAME = ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_LIBARY__URI = ARTIFACT__URI;

	/**
	 * The number of structural features of the '<em>Atl Libary</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_LIBARY_FEATURE_COUNT = ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.ModelAliasImpl <em>Model Alias</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.ModelAliasImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getModelAlias()
	 * @generated
	 */
	int MODEL_ALIAS = 6;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__COMMENTS = MODEL__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__NAME = MODEL__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__URI = MODEL__URI;

	/**
	 * The feature id for the '<em><b>Mm</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__MM = MODEL__MM;

	/**
	 * The feature id for the '<em><b>Is Temporary</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__IS_TEMPORARY = MODEL__IS_TEMPORARY;

	/**
	 * The feature id for the '<em><b>Decoratedmodel</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__DECORATEDMODEL = MODEL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Alias Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__ALIAS_NAME = MODEL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Model Alias</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS_FEATURE_COUNT = MODEL_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.GeneratorImpl <em>Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.GeneratorImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGenerator()
	 * @generated
	 */
	int GENERATOR = 7;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__COMMENTS = DOCUMENTABLE__COMMENTS;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__NEXT = DOCUMENTABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__NAME = DOCUMENTABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Uses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__USES = DOCUMENTABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Produce</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__PRODUCE = DOCUMENTABLE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR_FEATURE_COUNT = DOCUMENTABLE_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.EMF_GeneratorImpl <em>EMF Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.EMF_GeneratorImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getEMF_Generator()
	 * @generated
	 */
	int EMF_GENERATOR = 9;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_GENERATOR__COMMENTS = GENERATOR__COMMENTS;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_GENERATOR__NEXT = GENERATOR__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_GENERATOR__NAME = GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Uses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_GENERATOR__USES = GENERATOR__USES;

	/**
	 * The feature id for the '<em><b>Produce</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_GENERATOR__PRODUCE = GENERATOR__PRODUCE;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_GENERATOR__KIND = GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>EMF Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_GENERATOR_FEATURE_COUNT = GENERATOR_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.Useit_GeneratorImpl <em>Useit Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.Useit_GeneratorImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getUseit_Generator()
	 * @generated
	 */
	int USEIT_GENERATOR = 10;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USEIT_GENERATOR__COMMENTS = GENERATOR__COMMENTS;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USEIT_GENERATOR__NEXT = GENERATOR__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USEIT_GENERATOR__NAME = GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Uses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USEIT_GENERATOR__USES = GENERATOR__USES;

	/**
	 * The feature id for the '<em><b>Produce</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USEIT_GENERATOR__PRODUCE = GENERATOR__PRODUCE;

	/**
	 * The number of structural features of the '<em>Useit Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USEIT_GENERATOR_FEATURE_COUNT = GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.TopcasedGeneratorImpl <em>Topcased Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.TopcasedGeneratorImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getTopcasedGenerator()
	 * @generated
	 */
	int TOPCASED_GENERATOR = 11;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOPCASED_GENERATOR__COMMENTS = GENERATOR__COMMENTS;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOPCASED_GENERATOR__NEXT = GENERATOR__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOPCASED_GENERATOR__NAME = GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Uses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOPCASED_GENERATOR__USES = GENERATOR__USES;

	/**
	 * The feature id for the '<em><b>Produce</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOPCASED_GENERATOR__PRODUCE = GENERATOR__PRODUCE;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOPCASED_GENERATOR__KIND = GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Topcased Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOPCASED_GENERATOR_FEATURE_COUNT = GENERATOR_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.MMAliasImpl <em>MM Alias</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.MMAliasImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMMAlias()
	 * @generated
	 */
	int MM_ALIAS = 12;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__COMMENTS = MM__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__NAME = MM__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__URI = MM__URI;

	/**
	 * The feature id for the '<em><b>Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__HANDLER = MM__HANDLER;

	/**
	 * The feature id for the '<em><b>Decoratedmodel</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__DECORATEDMODEL = MM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Alias Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__ALIAS_NAME = MM_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>MM Alias</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS_FEATURE_COUNT = MM_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.CommentImpl <em>Comment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.CommentImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getComment()
	 * @generated
	 */
	int COMMENT = 14;

	/**
	 * The feature id for the '<em><b>Doc</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT__DOC = 0;

	/**
	 * The feature id for the '<em><b>Documented Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT__DOCUMENTED_ELEMENT = 1;

	/**
	 * The number of structural features of the '<em>Comment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.AM3_GeneratorImpl <em>AM3 Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.AM3_GeneratorImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAM3_Generator()
	 * @generated
	 */
	int AM3_GENERATOR = 15;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AM3_GENERATOR__COMMENTS = GENERATOR__COMMENTS;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AM3_GENERATOR__NEXT = GENERATOR__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AM3_GENERATOR__NAME = GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Uses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AM3_GENERATOR__USES = GENERATOR__USES;

	/**
	 * The feature id for the '<em><b>Produce</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AM3_GENERATOR__PRODUCE = GENERATOR__PRODUCE;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AM3_GENERATOR__KIND = GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>AM3 Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AM3_GENERATOR_FEATURE_COUNT = GENERATOR_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.Callable <em>Callable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.Callable
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCallable()
	 * @generated
	 */
	int CALLABLE = 16;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLABLE__NEXT = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLABLE__NAME = 1;

	/**
	 * The number of structural features of the '<em>Callable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLABLE_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.GMF_GeneratorImpl <em>GMF Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.GMF_GeneratorImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGMF_Generator()
	 * @generated
	 */
	int GMF_GENERATOR = 17;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GMF_GENERATOR__COMMENTS = GENERATOR__COMMENTS;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GMF_GENERATOR__NEXT = GENERATOR__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GMF_GENERATOR__NAME = GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Uses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GMF_GENERATOR__USES = GENERATOR__USES;

	/**
	 * The feature id for the '<em><b>Produce</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GMF_GENERATOR__PRODUCE = GENERATOR__PRODUCE;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GMF_GENERATOR__KIND = GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>GMF Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GMF_GENERATOR_FEATURE_COUNT = GENERATOR_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.Generic_GeneratorImpl <em>Generic Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.Generic_GeneratorImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGeneric_Generator()
	 * @generated
	 */
	int GENERIC_GENERATOR = 18;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__COMMENTS = GENERATOR__COMMENTS;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__NEXT = GENERATOR__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__NAME = GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Uses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__USES = GENERATOR__USES;

	/**
	 * The feature id for the '<em><b>Produce</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__PRODUCE = GENERATOR__PRODUCE;

	/**
	 * The number of structural features of the '<em>Generic Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR_FEATURE_COUNT = GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.MMhandler <em>MMhandler</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.MMhandler
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMMhandler()
	 * @generated
	 */
	int MMHANDLER = 19;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.TCGeneratorKind <em>TC Generator Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.TCGeneratorKind
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getTCGeneratorKind()
	 * @generated
	 */
	int TC_GENERATOR_KIND = 20;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.EMFGeneratorKind <em>EMF Generator Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.EMFGeneratorKind
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getEMFGeneratorKind()
	 * @generated
	 */
	int EMF_GENERATOR_KIND = 21;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.AM3GeneratorKind <em>AM3 Generator Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.AM3GeneratorKind
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAM3GeneratorKind()
	 * @generated
	 */
	int AM3_GENERATOR_KIND = 22;


	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.GMFGeneratorKind <em>GMF Generator Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.GMFGeneratorKind
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGMFGeneratorKind()
	 * @generated
	 */
	int GMF_GENERATOR_KIND = 23;


	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Model <em>Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model</em>'.
	 * @see de.urszeidler.eclipse.callchain.Model
	 * @generated
	 */
	EClass getModel();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.Model#getMm <em>Mm</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Mm</em>'.
	 * @see de.urszeidler.eclipse.callchain.Model#getMm()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Mm();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Model#isIsTemporary <em>Is Temporary</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Temporary</em>'.
	 * @see de.urszeidler.eclipse.callchain.Model#isIsTemporary()
	 * @see #getModel()
	 * @generated
	 */
	EAttribute getModel_IsTemporary();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.AtlRes <em>Atl Res</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Atl Res</em>'.
	 * @see de.urszeidler.eclipse.callchain.AtlRes
	 * @generated
	 */
	EClass getAtlRes();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.AtlRes#getSuperimpose <em>Superimpose</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Superimpose</em>'.
	 * @see de.urszeidler.eclipse.callchain.AtlRes#getSuperimpose()
	 * @see #getAtlRes()
	 * @generated
	 */
	EReference getAtlRes_Superimpose();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Call <em>Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call
	 * @generated
	 */
	EClass getCall();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Call#getIn <em>In</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>In</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getIn()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_In();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Call#getOut <em>Out</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Out</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getOut()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Out();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.Call#getRes <em>Res</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Res</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getRes()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Res();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Call#getLibarys <em>Libarys</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Libarys</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getLibarys()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Libarys();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isAllowInterModelReferences <em>Allow Inter Model References</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Allow Inter Model References</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isAllowInterModelReferences()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_AllowInterModelReferences();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isContinueAfterErrors <em>Continue After Errors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Continue After Errors</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isContinueAfterErrors()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_ContinueAfterErrors();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.Call#getArtifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Artifact</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getArtifact()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Artifact();

	/**
	 * Returns the meta object for the container reference '{@link de.urszeidler.eclipse.callchain.Call#getEnviorment <em>Enviorment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Enviorment</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getEnviorment()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Enviorment();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isShowSummary <em>Show Summary</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Show Summary</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isShowSummary()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_ShowSummary();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isPrintExecutionTime <em>Print Execution Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Print Execution Time</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isPrintExecutionTime()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_PrintExecutionTime();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isDisableAttributeHelperCache <em>Disable Attribute Helper Cache</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Disable Attribute Helper Cache</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isDisableAttributeHelperCache()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_DisableAttributeHelperCache();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isProfile <em>Profile</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Profile</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isProfile()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_Profile();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.MM <em>MM</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MM</em>'.
	 * @see de.urszeidler.eclipse.callchain.MM
	 * @generated
	 */
	EClass getMM();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.MM#getHandler <em>Handler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Handler</em>'.
	 * @see de.urszeidler.eclipse.callchain.MM#getHandler()
	 * @see #getMM()
	 * @generated
	 */
	EAttribute getMM_Handler();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Calls <em>Calls</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Calls</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls
	 * @generated
	 */
	EClass getCalls();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Calls#getCall <em>Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Call</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getCall()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_Call();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Calls#getGenerators <em>Generators</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Generators</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getGenerators()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_Generators();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Calls#getArtifacts <em>Artifacts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Artifacts</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getArtifacts()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_Artifacts();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Calls#getDefaultLib <em>Default Lib</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Default Lib</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getDefaultLib()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_DefaultLib();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Calls#getDefaultSuperImposed <em>Default Super Imposed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Default Super Imposed</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getDefaultSuperImposed()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_DefaultSuperImposed();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Calls#getStartPoints <em>Start Points</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Start Points</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getStartPoints()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_StartPoints();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.Calls#getDefaultStartPoint <em>Default Start Point</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Default Start Point</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getDefaultStartPoint()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_DefaultStartPoint();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Calls#isLogDefault <em>Log Default</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Log Default</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#isLogDefault()
	 * @see #getCalls()
	 * @generated
	 */
	EAttribute getCalls_LogDefault();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.AtlLibary <em>Atl Libary</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Atl Libary</em>'.
	 * @see de.urszeidler.eclipse.callchain.AtlLibary
	 * @generated
	 */
	EClass getAtlLibary();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.ModelAlias <em>Model Alias</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Alias</em>'.
	 * @see de.urszeidler.eclipse.callchain.ModelAlias
	 * @generated
	 */
	EClass getModelAlias();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.ModelAlias#getDecoratedmodel <em>Decoratedmodel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Decoratedmodel</em>'.
	 * @see de.urszeidler.eclipse.callchain.ModelAlias#getDecoratedmodel()
	 * @see #getModelAlias()
	 * @generated
	 */
	EReference getModelAlias_Decoratedmodel();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.ModelAlias#getAliasName <em>Alias Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Alias Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.ModelAlias#getAliasName()
	 * @see #getModelAlias()
	 * @generated
	 */
	EAttribute getModelAlias_AliasName();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Generator <em>Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generator</em>'.
	 * @see de.urszeidler.eclipse.callchain.Generator
	 * @generated
	 */
	EClass getGenerator();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Generator#getUses <em>Uses</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Uses</em>'.
	 * @see de.urszeidler.eclipse.callchain.Generator#getUses()
	 * @see #getGenerator()
	 * @generated
	 */
	EReference getGenerator_Uses();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Generator#getProduce <em>Produce</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Produce</em>'.
	 * @see de.urszeidler.eclipse.callchain.Generator#getProduce()
	 * @see #getGenerator()
	 * @generated
	 */
	EReference getGenerator_Produce();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Artifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Artifact</em>'.
	 * @see de.urszeidler.eclipse.callchain.Artifact
	 * @generated
	 */
	EClass getArtifact();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Artifact#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.Artifact#getName()
	 * @see #getArtifact()
	 * @generated
	 */
	EAttribute getArtifact_Name();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Artifact#getUri <em>Uri</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Uri</em>'.
	 * @see de.urszeidler.eclipse.callchain.Artifact#getUri()
	 * @see #getArtifact()
	 * @generated
	 */
	EAttribute getArtifact_Uri();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.EMF_Generator <em>EMF Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>EMF Generator</em>'.
	 * @see de.urszeidler.eclipse.callchain.EMF_Generator
	 * @generated
	 */
	EClass getEMF_Generator();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.EMF_Generator#getKind <em>Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see de.urszeidler.eclipse.callchain.EMF_Generator#getKind()
	 * @see #getEMF_Generator()
	 * @generated
	 */
	EAttribute getEMF_Generator_Kind();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Useit_Generator <em>Useit Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Useit Generator</em>'.
	 * @see de.urszeidler.eclipse.callchain.Useit_Generator
	 * @generated
	 */
	EClass getUseit_Generator();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.TopcasedGenerator <em>Topcased Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Topcased Generator</em>'.
	 * @see de.urszeidler.eclipse.callchain.TopcasedGenerator
	 * @generated
	 */
	EClass getTopcasedGenerator();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.TopcasedGenerator#getKind <em>Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see de.urszeidler.eclipse.callchain.TopcasedGenerator#getKind()
	 * @see #getTopcasedGenerator()
	 * @generated
	 */
	EAttribute getTopcasedGenerator_Kind();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.MMAlias <em>MM Alias</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MM Alias</em>'.
	 * @see de.urszeidler.eclipse.callchain.MMAlias
	 * @generated
	 */
	EClass getMMAlias();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.MMAlias#getDecoratedmodel <em>Decoratedmodel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Decoratedmodel</em>'.
	 * @see de.urszeidler.eclipse.callchain.MMAlias#getDecoratedmodel()
	 * @see #getMMAlias()
	 * @generated
	 */
	EReference getMMAlias_Decoratedmodel();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.MMAlias#getAliasName <em>Alias Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Alias Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.MMAlias#getAliasName()
	 * @see #getMMAlias()
	 * @generated
	 */
	EAttribute getMMAlias_AliasName();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Documentable <em>Documentable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Documentable</em>'.
	 * @see de.urszeidler.eclipse.callchain.Documentable
	 * @generated
	 */
	EClass getDocumentable();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Documentable#getComments <em>Comments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Comments</em>'.
	 * @see de.urszeidler.eclipse.callchain.Documentable#getComments()
	 * @see #getDocumentable()
	 * @generated
	 */
	EReference getDocumentable_Comments();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Comment <em>Comment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Comment</em>'.
	 * @see de.urszeidler.eclipse.callchain.Comment
	 * @generated
	 */
	EClass getComment();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Comment#getDoc <em>Doc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Doc</em>'.
	 * @see de.urszeidler.eclipse.callchain.Comment#getDoc()
	 * @see #getComment()
	 * @generated
	 */
	EAttribute getComment_Doc();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Comment#getDocumentedElement <em>Documented Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Documented Element</em>'.
	 * @see de.urszeidler.eclipse.callchain.Comment#getDocumentedElement()
	 * @see #getComment()
	 * @generated
	 */
	EReference getComment_DocumentedElement();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.AM3_Generator <em>AM3 Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>AM3 Generator</em>'.
	 * @see de.urszeidler.eclipse.callchain.AM3_Generator
	 * @generated
	 */
	EClass getAM3_Generator();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.AM3_Generator#getKind <em>Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see de.urszeidler.eclipse.callchain.AM3_Generator#getKind()
	 * @see #getAM3_Generator()
	 * @generated
	 */
	EAttribute getAM3_Generator_Kind();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Callable <em>Callable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Callable</em>'.
	 * @see de.urszeidler.eclipse.callchain.Callable
	 * @generated
	 */
	EClass getCallable();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.Callable#getNext <em>Next</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Next</em>'.
	 * @see de.urszeidler.eclipse.callchain.Callable#getNext()
	 * @see #getCallable()
	 * @generated
	 */
	EReference getCallable_Next();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Callable#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.Callable#getName()
	 * @see #getCallable()
	 * @generated
	 */
	EAttribute getCallable_Name();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.GMF_Generator <em>GMF Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GMF Generator</em>'.
	 * @see de.urszeidler.eclipse.callchain.GMF_Generator
	 * @generated
	 */
	EClass getGMF_Generator();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.GMF_Generator#getKind <em>Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see de.urszeidler.eclipse.callchain.GMF_Generator#getKind()
	 * @see #getGMF_Generator()
	 * @generated
	 */
	EAttribute getGMF_Generator_Kind();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Generic_Generator <em>Generic Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generic Generator</em>'.
	 * @see de.urszeidler.eclipse.callchain.Generic_Generator
	 * @generated
	 */
	EClass getGeneric_Generator();

	/**
	 * Returns the meta object for enum '{@link de.urszeidler.eclipse.callchain.MMhandler <em>MMhandler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>MMhandler</em>'.
	 * @see de.urszeidler.eclipse.callchain.MMhandler
	 * @generated
	 */
	EEnum getMMhandler();

	/**
	 * Returns the meta object for enum '{@link de.urszeidler.eclipse.callchain.TCGeneratorKind <em>TC Generator Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>TC Generator Kind</em>'.
	 * @see de.urszeidler.eclipse.callchain.TCGeneratorKind
	 * @generated
	 */
	EEnum getTCGeneratorKind();

	/**
	 * Returns the meta object for enum '{@link de.urszeidler.eclipse.callchain.EMFGeneratorKind <em>EMF Generator Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>EMF Generator Kind</em>'.
	 * @see de.urszeidler.eclipse.callchain.EMFGeneratorKind
	 * @generated
	 */
	EEnum getEMFGeneratorKind();

	/**
	 * Returns the meta object for enum '{@link de.urszeidler.eclipse.callchain.AM3GeneratorKind <em>AM3 Generator Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>AM3 Generator Kind</em>'.
	 * @see de.urszeidler.eclipse.callchain.AM3GeneratorKind
	 * @generated
	 */
	EEnum getAM3GeneratorKind();

	/**
	 * Returns the meta object for enum '{@link de.urszeidler.eclipse.callchain.GMFGeneratorKind <em>GMF Generator Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>GMF Generator Kind</em>'.
	 * @see de.urszeidler.eclipse.callchain.GMFGeneratorKind
	 * @generated
	 */
	EEnum getGMFGeneratorKind();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	CallchainFactory getCallchainFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.ModelImpl <em>Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.ModelImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getModel()
		 * @generated
		 */
		EClass MODEL = eINSTANCE.getModel();

		/**
		 * The meta object literal for the '<em><b>Mm</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL__MM = eINSTANCE.getModel_Mm();

		/**
		 * The meta object literal for the '<em><b>Is Temporary</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL__IS_TEMPORARY = eINSTANCE.getModel_IsTemporary();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.AtlResImpl <em>Atl Res</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.AtlResImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAtlRes()
		 * @generated
		 */
		EClass ATL_RES = eINSTANCE.getAtlRes();

		/**
		 * The meta object literal for the '<em><b>Superimpose</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ATL_RES__SUPERIMPOSE = eINSTANCE.getAtlRes_Superimpose();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.CallImpl <em>Call</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.CallImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCall()
		 * @generated
		 */
		EClass CALL = eINSTANCE.getCall();

		/**
		 * The meta object literal for the '<em><b>In</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__IN = eINSTANCE.getCall_In();

		/**
		 * The meta object literal for the '<em><b>Out</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__OUT = eINSTANCE.getCall_Out();

		/**
		 * The meta object literal for the '<em><b>Res</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__RES = eINSTANCE.getCall_Res();

		/**
		 * The meta object literal for the '<em><b>Libarys</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__LIBARYS = eINSTANCE.getCall_Libarys();

		/**
		 * The meta object literal for the '<em><b>Allow Inter Model References</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__ALLOW_INTER_MODEL_REFERENCES = eINSTANCE.getCall_AllowInterModelReferences();

		/**
		 * The meta object literal for the '<em><b>Continue After Errors</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__CONTINUE_AFTER_ERRORS = eINSTANCE.getCall_ContinueAfterErrors();

		/**
		 * The meta object literal for the '<em><b>Artifact</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__ARTIFACT = eINSTANCE.getCall_Artifact();

		/**
		 * The meta object literal for the '<em><b>Enviorment</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__ENVIORMENT = eINSTANCE.getCall_Enviorment();

		/**
		 * The meta object literal for the '<em><b>Show Summary</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__SHOW_SUMMARY = eINSTANCE.getCall_ShowSummary();

		/**
		 * The meta object literal for the '<em><b>Print Execution Time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__PRINT_EXECUTION_TIME = eINSTANCE.getCall_PrintExecutionTime();

		/**
		 * The meta object literal for the '<em><b>Disable Attribute Helper Cache</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__DISABLE_ATTRIBUTE_HELPER_CACHE = eINSTANCE.getCall_DisableAttributeHelperCache();

		/**
		 * The meta object literal for the '<em><b>Profile</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__PROFILE = eINSTANCE.getCall_Profile();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.MMImpl <em>MM</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.MMImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMM()
		 * @generated
		 */
		EClass MM = eINSTANCE.getMM();

		/**
		 * The meta object literal for the '<em><b>Handler</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MM__HANDLER = eINSTANCE.getMM_Handler();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.CallsImpl <em>Calls</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.CallsImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCalls()
		 * @generated
		 */
		EClass CALLS = eINSTANCE.getCalls();

		/**
		 * The meta object literal for the '<em><b>Call</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__CALL = eINSTANCE.getCalls_Call();

		/**
		 * The meta object literal for the '<em><b>Generators</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__GENERATORS = eINSTANCE.getCalls_Generators();

		/**
		 * The meta object literal for the '<em><b>Artifacts</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__ARTIFACTS = eINSTANCE.getCalls_Artifacts();

		/**
		 * The meta object literal for the '<em><b>Default Lib</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__DEFAULT_LIB = eINSTANCE.getCalls_DefaultLib();

		/**
		 * The meta object literal for the '<em><b>Default Super Imposed</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__DEFAULT_SUPER_IMPOSED = eINSTANCE.getCalls_DefaultSuperImposed();

		/**
		 * The meta object literal for the '<em><b>Start Points</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__START_POINTS = eINSTANCE.getCalls_StartPoints();

		/**
		 * The meta object literal for the '<em><b>Default Start Point</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__DEFAULT_START_POINT = eINSTANCE.getCalls_DefaultStartPoint();

		/**
		 * The meta object literal for the '<em><b>Log Default</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALLS__LOG_DEFAULT = eINSTANCE.getCalls_LogDefault();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.AtlLibaryImpl <em>Atl Libary</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.AtlLibaryImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAtlLibary()
		 * @generated
		 */
		EClass ATL_LIBARY = eINSTANCE.getAtlLibary();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.ModelAliasImpl <em>Model Alias</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.ModelAliasImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getModelAlias()
		 * @generated
		 */
		EClass MODEL_ALIAS = eINSTANCE.getModelAlias();

		/**
		 * The meta object literal for the '<em><b>Decoratedmodel</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ALIAS__DECORATEDMODEL = eINSTANCE.getModelAlias_Decoratedmodel();

		/**
		 * The meta object literal for the '<em><b>Alias Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_ALIAS__ALIAS_NAME = eINSTANCE.getModelAlias_AliasName();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.GeneratorImpl <em>Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.GeneratorImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGenerator()
		 * @generated
		 */
		EClass GENERATOR = eINSTANCE.getGenerator();

		/**
		 * The meta object literal for the '<em><b>Uses</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERATOR__USES = eINSTANCE.getGenerator_Uses();

		/**
		 * The meta object literal for the '<em><b>Produce</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERATOR__PRODUCE = eINSTANCE.getGenerator_Produce();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.ArtifactImpl <em>Artifact</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.ArtifactImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getArtifact()
		 * @generated
		 */
		EClass ARTIFACT = eINSTANCE.getArtifact();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARTIFACT__NAME = eINSTANCE.getArtifact_Name();

		/**
		 * The meta object literal for the '<em><b>Uri</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARTIFACT__URI = eINSTANCE.getArtifact_Uri();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.EMF_GeneratorImpl <em>EMF Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.EMF_GeneratorImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getEMF_Generator()
		 * @generated
		 */
		EClass EMF_GENERATOR = eINSTANCE.getEMF_Generator();

		/**
		 * The meta object literal for the '<em><b>Kind</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EMF_GENERATOR__KIND = eINSTANCE.getEMF_Generator_Kind();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.Useit_GeneratorImpl <em>Useit Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.Useit_GeneratorImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getUseit_Generator()
		 * @generated
		 */
		EClass USEIT_GENERATOR = eINSTANCE.getUseit_Generator();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.TopcasedGeneratorImpl <em>Topcased Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.TopcasedGeneratorImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getTopcasedGenerator()
		 * @generated
		 */
		EClass TOPCASED_GENERATOR = eINSTANCE.getTopcasedGenerator();

		/**
		 * The meta object literal for the '<em><b>Kind</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TOPCASED_GENERATOR__KIND = eINSTANCE.getTopcasedGenerator_Kind();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.MMAliasImpl <em>MM Alias</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.MMAliasImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMMAlias()
		 * @generated
		 */
		EClass MM_ALIAS = eINSTANCE.getMMAlias();

		/**
		 * The meta object literal for the '<em><b>Decoratedmodel</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MM_ALIAS__DECORATEDMODEL = eINSTANCE.getMMAlias_Decoratedmodel();

		/**
		 * The meta object literal for the '<em><b>Alias Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MM_ALIAS__ALIAS_NAME = eINSTANCE.getMMAlias_AliasName();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.Documentable <em>Documentable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.Documentable
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getDocumentable()
		 * @generated
		 */
		EClass DOCUMENTABLE = eINSTANCE.getDocumentable();

		/**
		 * The meta object literal for the '<em><b>Comments</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENTABLE__COMMENTS = eINSTANCE.getDocumentable_Comments();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.CommentImpl <em>Comment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.CommentImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getComment()
		 * @generated
		 */
		EClass COMMENT = eINSTANCE.getComment();

		/**
		 * The meta object literal for the '<em><b>Doc</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMMENT__DOC = eINSTANCE.getComment_Doc();

		/**
		 * The meta object literal for the '<em><b>Documented Element</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMMENT__DOCUMENTED_ELEMENT = eINSTANCE.getComment_DocumentedElement();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.AM3_GeneratorImpl <em>AM3 Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.AM3_GeneratorImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAM3_Generator()
		 * @generated
		 */
		EClass AM3_GENERATOR = eINSTANCE.getAM3_Generator();

		/**
		 * The meta object literal for the '<em><b>Kind</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AM3_GENERATOR__KIND = eINSTANCE.getAM3_Generator_Kind();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.Callable <em>Callable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.Callable
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCallable()
		 * @generated
		 */
		EClass CALLABLE = eINSTANCE.getCallable();

		/**
		 * The meta object literal for the '<em><b>Next</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLABLE__NEXT = eINSTANCE.getCallable_Next();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALLABLE__NAME = eINSTANCE.getCallable_Name();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.GMF_GeneratorImpl <em>GMF Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.GMF_GeneratorImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGMF_Generator()
		 * @generated
		 */
		EClass GMF_GENERATOR = eINSTANCE.getGMF_Generator();

		/**
		 * The meta object literal for the '<em><b>Kind</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GMF_GENERATOR__KIND = eINSTANCE.getGMF_Generator_Kind();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.Generic_GeneratorImpl <em>Generic Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.Generic_GeneratorImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGeneric_Generator()
		 * @generated
		 */
		EClass GENERIC_GENERATOR = eINSTANCE.getGeneric_Generator();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.MMhandler <em>MMhandler</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.MMhandler
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMMhandler()
		 * @generated
		 */
		EEnum MMHANDLER = eINSTANCE.getMMhandler();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.TCGeneratorKind <em>TC Generator Kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.TCGeneratorKind
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getTCGeneratorKind()
		 * @generated
		 */
		EEnum TC_GENERATOR_KIND = eINSTANCE.getTCGeneratorKind();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.EMFGeneratorKind <em>EMF Generator Kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.EMFGeneratorKind
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getEMFGeneratorKind()
		 * @generated
		 */
		EEnum EMF_GENERATOR_KIND = eINSTANCE.getEMFGeneratorKind();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.AM3GeneratorKind <em>AM3 Generator Kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.AM3GeneratorKind
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAM3GeneratorKind()
		 * @generated
		 */
		EEnum AM3_GENERATOR_KIND = eINSTANCE.getAM3GeneratorKind();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.GMFGeneratorKind <em>GMF Generator Kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.GMFGeneratorKind
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGMFGeneratorKind()
		 * @generated
		 */
		EEnum GMF_GENERATOR_KIND = eINSTANCE.getGMFGeneratorKind();

	}

} //CallchainPackage
