/**
 * <copyright>
 * </copyright>
 *
 * $Id: Calls.java,v 1.1 2008/04/09 22:40:57 urs Exp $
 */
package de.urszeidler.eclipse.callchain;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Calls</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.urszeidler.eclipse.callchain.Calls#getCall <em>Call</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Calls#getGenerators <em>Generators</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Calls#getArtifacts <em>Artifacts</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Calls#getDefaultLib <em>Default Lib</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Calls#getDefaultSuperImposed <em>Default Super Imposed</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Calls#getStartPoints <em>Start Points</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Calls#getDefaultStartPoint <em>Default Start Point</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Calls#isLogDefault <em>Log Default</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCalls()
 * @model
 * @generated
 */
public interface Calls extends Documentable {
	/**
	 * Returns the value of the '<em><b>Call</b></em>' containment reference list.
	 * The list contents are of type {@link de.urszeidler.eclipse.callchain.Call}.
	 * It is bidirectional and its opposite is '{@link de.urszeidler.eclipse.callchain.Call#getEnviorment <em>Enviorment</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Call</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Call</em>' containment reference list.
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCalls_Call()
	 * @see de.urszeidler.eclipse.callchain.Call#getEnviorment
	 * @model opposite="enviorment" containment="true"
	 * @generated
	 */
	EList<Call> getCall();

	/**
	 * Returns the value of the '<em><b>Generators</b></em>' containment reference list.
	 * The list contents are of type {@link de.urszeidler.eclipse.callchain.Generator}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Generators</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Generators</em>' containment reference list.
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCalls_Generators()
	 * @model containment="true"
	 * @generated
	 */
	EList<Generator> getGenerators();

	/**
	 * Returns the value of the '<em><b>Artifacts</b></em>' containment reference list.
	 * The list contents are of type {@link de.urszeidler.eclipse.callchain.Artifact}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Artifacts</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Artifacts</em>' containment reference list.
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCalls_Artifacts()
	 * @model containment="true"
	 * @generated
	 */
	EList<Artifact> getArtifacts();

	/**
	 * Returns the value of the '<em><b>Default Lib</b></em>' reference list.
	 * The list contents are of type {@link de.urszeidler.eclipse.callchain.AtlLibary}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Default Lib</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Default Lib</em>' reference list.
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCalls_DefaultLib()
	 * @model
	 * @generated
	 */
	EList<AtlLibary> getDefaultLib();

	/**
	 * Returns the value of the '<em><b>Default Super Imposed</b></em>' reference list.
	 * The list contents are of type {@link de.urszeidler.eclipse.callchain.AtlRes}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Default Super Imposed</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Default Super Imposed</em>' reference list.
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCalls_DefaultSuperImposed()
	 * @model
	 * @generated
	 */
	EList<AtlRes> getDefaultSuperImposed();

	/**
	 * Returns the value of the '<em><b>Start Points</b></em>' reference list.
	 * The list contents are of type {@link de.urszeidler.eclipse.callchain.Call}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Points</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Points</em>' reference list.
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCalls_StartPoints()
	 * @model
	 * @generated
	 */
	EList<Call> getStartPoints();

	/**
	 * Returns the value of the '<em><b>Default Start Point</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Default Start Point</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Default Start Point</em>' reference.
	 * @see #setDefaultStartPoint(Call)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCalls_DefaultStartPoint()
	 * @model
	 * @generated
	 */
	Call getDefaultStartPoint();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.Calls#getDefaultStartPoint <em>Default Start Point</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Default Start Point</em>' reference.
	 * @see #getDefaultStartPoint()
	 * @generated
	 */
	void setDefaultStartPoint(Call value);

	/**
	 * Returns the value of the '<em><b>Log Default</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Log Default</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Log Default</em>' attribute.
	 * @see #setLogDefault(boolean)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCalls_LogDefault()
	 * @model
	 * @generated
	 */
	boolean isLogDefault();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.Calls#isLogDefault <em>Log Default</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Log Default</em>' attribute.
	 * @see #isLogDefault()
	 * @generated
	 */
	void setLogDefault(boolean value);

} // Calls
