/**
 * <copyright>
 * </copyright>
 *
 * $Id: GMFGeneratorKind.java,v 1.1 2008/04/09 22:40:59 urs Exp $
 */
package de.urszeidler.eclipse.callchain;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>GMF Generator Kind</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getGMFGeneratorKind()
 * @model
 * @generated
 */
public enum GMFGeneratorKind implements Enumerator {
	/**
	 * The '<em><b>Graph Model</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GRAPH_MODEL_VALUE
	 * @generated
	 * @ordered
	 */
	GRAPH_MODEL(0, "GraphModel", "GraphModel"),

	/**
	 * The '<em><b>Mapping Model</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MAPPING_MODEL_VALUE
	 * @generated
	 * @ordered
	 */
	MAPPING_MODEL(0, "MappingModel", "MappingModel"),

	/**
	 * The '<em><b>Tools Model</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TOOLS_MODEL_VALUE
	 * @generated
	 * @ordered
	 */
	TOOLS_MODEL(1, "ToolsModel", "ToolsModel"),

	/**
	 * The '<em><b>Gen Model</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GEN_MODEL_VALUE
	 * @generated
	 * @ordered
	 */
	GEN_MODEL(2, "GenModel", "GenModel"),

	/**
	 * The '<em><b>Diagram Generator</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DIAGRAM_GENERATOR_VALUE
	 * @generated
	 * @ordered
	 */
	DIAGRAM_GENERATOR(3, "DiagramGenerator", "DiagramGenerator");

	/**
	 * The '<em><b>Graph Model</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Graph Model</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #GRAPH_MODEL
	 * @model name="GraphModel"
	 * @generated
	 * @ordered
	 */
	public static final int GRAPH_MODEL_VALUE = 0;

	/**
	 * The '<em><b>Mapping Model</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Mapping Model</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MAPPING_MODEL
	 * @model name="MappingModel"
	 * @generated
	 * @ordered
	 */
	public static final int MAPPING_MODEL_VALUE = 0;

	/**
	 * The '<em><b>Tools Model</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Tools Model</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TOOLS_MODEL
	 * @model name="ToolsModel"
	 * @generated
	 * @ordered
	 */
	public static final int TOOLS_MODEL_VALUE = 1;

	/**
	 * The '<em><b>Gen Model</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Gen Model</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #GEN_MODEL
	 * @model name="GenModel"
	 * @generated
	 * @ordered
	 */
	public static final int GEN_MODEL_VALUE = 2;

	/**
	 * The '<em><b>Diagram Generator</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Diagram Generator</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DIAGRAM_GENERATOR
	 * @model name="DiagramGenerator"
	 * @generated
	 * @ordered
	 */
	public static final int DIAGRAM_GENERATOR_VALUE = 3;

	/**
	 * An array of all the '<em><b>GMF Generator Kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final GMFGeneratorKind[] VALUES_ARRAY =
		new GMFGeneratorKind[] {
			GRAPH_MODEL,
			MAPPING_MODEL,
			TOOLS_MODEL,
			GEN_MODEL,
			DIAGRAM_GENERATOR,
		};

	/**
	 * A public read-only list of all the '<em><b>GMF Generator Kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<GMFGeneratorKind> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>GMF Generator Kind</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static GMFGeneratorKind get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			GMFGeneratorKind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>GMF Generator Kind</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static GMFGeneratorKind getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			GMFGeneratorKind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>GMF Generator Kind</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static GMFGeneratorKind get(int value) {
		switch (value) {
			case GRAPH_MODEL_VALUE: return GRAPH_MODEL;
			case TOOLS_MODEL_VALUE: return TOOLS_MODEL;
			case GEN_MODEL_VALUE: return GEN_MODEL;
			case DIAGRAM_GENERATOR_VALUE: return DIAGRAM_GENERATOR;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private GMFGeneratorKind(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //GMFGeneratorKind
