/**
 * <copyright>
 * </copyright>
 *
 * $Id: MMhandler.java,v 1.1 2008/04/09 22:40:59 urs Exp $
 */
package de.urszeidler.eclipse.callchain;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>MMhandler</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getMMhandler()
 * @model
 * @generated
 */
public enum MMhandler implements Enumerator {
	/**
	 * The '<em><b>EMF</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EMF
	 * @generated
	 * @ordered
	 */
	EMF_LITERAL(0, "EMF", "EMF"),

	/**
	 * The '<em><b>MDR</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MDR
	 * @generated
	 * @ordered
	 */
	MDR_LITERAL(1, "MDR", "MDR"),

	/**
	 * The '<em><b>UML2</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #UML2
	 * @generated
	 * @ordered
	 */
	UML2_LITERAL(2, "UML2", "UML2");

	/**
	 * The '<em><b>EMF</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>EMF</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #EMF_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int EMF = 0;

	/**
	 * The '<em><b>MDR</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>MDR</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MDR_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int MDR = 1;

	/**
	 * The '<em><b>UML2</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>UML2</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #UML2_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int UML2 = 2;

	/**
	 * An array of all the '<em><b>MMhandler</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final MMhandler[] VALUES_ARRAY =
		new MMhandler[] {
			EMF_LITERAL,
			MDR_LITERAL,
			UML2_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>MMhandler</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<MMhandler> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>MMhandler</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static MMhandler get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			MMhandler result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>MMhandler</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static MMhandler getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			MMhandler result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>MMhandler</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static MMhandler get(int value) {
		switch (value) {
			case EMF: return EMF_LITERAL;
			case MDR: return MDR_LITERAL;
			case UML2: return UML2_LITERAL;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private MMhandler(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //MMhandler
