package de.urszeidler.eclipse.callchain.diagram.edit.parts;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.diagram.edit.policies.TopcasedGeneratorItemSemanticEditPolicy;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class TopcasedGeneratorEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2023;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public TopcasedGeneratorEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new TopcasedGeneratorItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		LayoutEditPolicy lep = new LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		TopcasedGeneratorFigure figure = new TopcasedGeneratorFigure();
		return primaryShape = figure;
	}

	/**
	 * @generated
	 */
	public TopcasedGeneratorFigure getPrimaryShape() {
		return (TopcasedGeneratorFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof TopcasedGeneratorKindEditPart) {
			((TopcasedGeneratorKindEditPart) childEditPart)
					.setLabel(getPrimaryShape()
							.getFigureTopcasedGeneratorkindFigure());
			return true;
		}
		if (childEditPart instanceof TopcasedGeneratorNameEditPart) {
			((TopcasedGeneratorNameEditPart) childEditPart)
					.setLabel(getPrimaryShape()
							.getFigureTopcasedGeneratornameFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {

		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {

		return super.getContentPaneFor(editPart);
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(getMapMode()
				.DPtoLP(20), getMapMode().DPtoLP(20));
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(getMapMode().DPtoLP(5));
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(CallchainVisualIDRegistry
				.getType(TopcasedGeneratorKindEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public class TopcasedGeneratorFigure extends RectangleFigure {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureTopcasedGeneratorkindFigure;
		/**
		 * @generated
		 */
		private WrappingLabel fFigureTopcasedGeneratornameFigure;

		/**
		 * @generated not
		 */
		public TopcasedGeneratorFigure() {
			//TODO : fixx this

			//			FlowLayout layoutThis = new FlowLayout();
			//			layoutThis.setStretchMinorAxis(false);
			//			layoutThis.setMinorAlignment(FlowLayout.ALIGN_CENTER);
			//
			//			layoutThis.setMajorAlignment(FlowLayout.ALIGN_CENTER);
			//			layoutThis.setMajorSpacing(5);
			//			layoutThis.setMinorSpacing(5);
			//			layoutThis.setHorizontal(false);
			//			
			ToolbarLayout layout = new ToolbarLayout();
			layout.setStretchMinorAxis(true);
			layout.setMinorAlignment(ToolbarLayout.ALIGN_CENTER);

			this.setLayoutManager(layout);

			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(20),
					getMapMode().DPtoLP(20)));
			createContents();
		}

		/**
		 * @generated not
		 */
		private void createContents() {

			WrappingLabel topcasedGenerator0 = new WrappingLabel(
					"TopcasedGenerator",
					CallchainElementTypes.getImage(((View) getModel())
							.getElement().eClass()));
			topcasedGenerator0.setAlignment(PositionConstants.CENTER);

			this.add(topcasedGenerator0);

			fFigureTopcasedGeneratornameFigure = new WrappingLabel();
			fFigureTopcasedGeneratornameFigure.setText("[null]");
			fFigureTopcasedGeneratornameFigure
					.setAlignment(PositionConstants.CENTER);
			this.add(fFigureTopcasedGeneratornameFigure);

			fFigureTopcasedGeneratorkindFigure = new WrappingLabel();
			fFigureTopcasedGeneratorkindFigure.setText("[null]");
			fFigureTopcasedGeneratorkindFigure
					.setAlignment(PositionConstants.CENTER);
			this.add(fFigureTopcasedGeneratorkindFigure);

		}

		/**
		 * @generated
		 */
		private boolean myUseLocalCoordinates = false;

		/**
		 * @generated
		 */
		protected boolean useLocalCoordinates() {
			return myUseLocalCoordinates;
		}

		/**
		 * @generated
		 */
		protected void setUseLocalCoordinates(boolean useLocalCoordinates) {
			myUseLocalCoordinates = useLocalCoordinates;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureTopcasedGeneratorkindFigure() {
			return fFigureTopcasedGeneratorkindFigure;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureTopcasedGeneratornameFigure() {
			return fFigureTopcasedGeneratornameFigure;
		}

	}

}
