package de.urszeidler.eclipse.callchain.diagram.providers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.modelingassistant.ModelingAssistantProvider;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.dialogs.ElementListSelectionDialog;

import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallsEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Useit_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainDiagramEditorPlugin;
import de.urszeidler.eclipse.callchain.diagram.part.Messages;

/**
 * @generated
 */
public class CallchainModelingAssistantProvider extends
		ModelingAssistantProvider {

	/**
	 * @generated
	 */
	public List getTypesForPopupBar(IAdaptable host) {
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart instanceof CallsEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.Model_2015);
			types.add(CallchainElementTypes.AtlRes_2016);
			types.add(CallchainElementTypes.Call_2017);
			types.add(CallchainElementTypes.MM_2018);
			types.add(CallchainElementTypes.AtlLibary_2019);
			types.add(CallchainElementTypes.Artifact_2020);
			types.add(CallchainElementTypes.EMF_Generator_2021);
			types.add(CallchainElementTypes.Useit_Generator_2022);
			types.add(CallchainElementTypes.TopcasedGenerator_2023);
			types.add(CallchainElementTypes.Comment_2024);
			types.add(CallchainElementTypes.AM3_Generator_2025);
			types.add(CallchainElementTypes.GMF_Generator_2026);
			types.add(CallchainElementTypes.Generic_Generator_2027);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated not
	 */
	public List getRelTypesOnSource(IAdaptable source) {
		return getRelTypesOnSource_intern(source);

		//		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
		//				.getAdapter(IGraphicalEditPart.class);
		//		if (sourceEditPart instanceof ModelEditPart) {
		//			List types = new ArrayList();
		//			types.add(CallchainElementTypes.ModelMm_4018);
		//			return types;
		//		}
		//		if (sourceEditPart instanceof AtlResEditPart) {
		//			List types = new ArrayList();
		//			types.add(CallchainElementTypes.AtlResSuperimpose_4019);
		//			return types;
		//		}
		//		if (sourceEditPart instanceof CallEditPart) {
		//			List types = new ArrayList();
		//			types.add(CallchainElementTypes.ModelAlias_4016);
		//			types.add(CallchainElementTypes.CallIn_4020);
		//			types.add(CallchainElementTypes.CallOut_4021);
		//			types.add(CallchainElementTypes.CallRes_4022);
		//			types.add(CallchainElementTypes.CallLibarys_4023);
		//			types.add(CallchainElementTypes.CallArtifact_4024);
		//			return types;
		//		}
		//		if (sourceEditPart instanceof CommentEditPart) {
		//			List types = new ArrayList();
		//			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		//			return types;
		//		}
		//		return Collections.EMPTY_LIST;
	}

	private List getRelTypesOnSource_intern(IAdaptable source) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof ModelEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.ModelMm_4018);
			return types;
		}
		if (sourceEditPart instanceof AtlResEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.AtlResSuperimpose_4019);
			return types;
		}
		if (sourceEditPart instanceof CallEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.ModelAlias_4016);
			types.add(CallchainElementTypes.CallIn_4020);
			types.add(CallchainElementTypes.CallOut_4021);
			types.add(CallchainElementTypes.CallRes_4022);
			types.add(CallchainElementTypes.CallLibarys_4023);
			types.add(CallchainElementTypes.CallArtifact_4024);
			return types;
		}

		if (sourceEditPart instanceof AM3_GeneratorEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.GeneratorProduce_4027);
			types.add(CallchainElementTypes.GeneratorUses_4026);
			return types;
		}
		if (sourceEditPart instanceof GMF_GeneratorEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.GeneratorProduce_4027);
			types.add(CallchainElementTypes.GeneratorUses_4026);
			return types;
		}
		if (sourceEditPart instanceof TopcasedGeneratorEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.GeneratorProduce_4027);
			types.add(CallchainElementTypes.GeneratorUses_4026);
			return types;
		}
		if (sourceEditPart instanceof EMF_GeneratorEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.GeneratorProduce_4027);
			types.add(CallchainElementTypes.GeneratorUses_4026);
			return types;
		}
		if (sourceEditPart instanceof Useit_GeneratorEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.GeneratorProduce_4027);
			types.add(CallchainElementTypes.GeneratorUses_4026);//TODO : All artifacts
			return types;
		}

		if (sourceEditPart instanceof CommentEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnTarget(IAdaptable target) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof ModelEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.ModelAlias_4016);
			types.add(CallchainElementTypes.MMAlias_4017);
			types.add(CallchainElementTypes.CallIn_4020);
			types.add(CallchainElementTypes.CallOut_4021);
			return types;
		}
		if (targetEditPart instanceof AtlResEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.AtlResSuperimpose_4019);
			types.add(CallchainElementTypes.CallRes_4022);
			return types;
		}
		if (targetEditPart instanceof MMEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.ModelMm_4018);
			return types;
		}
		if (targetEditPart instanceof AtlLibaryEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.CallLibarys_4023);
			return types;
		}
		if (targetEditPart instanceof ArtifactEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.CallArtifact_4024);
			types.add(CallchainElementTypes.GeneratorUses_4026);
			types.add(CallchainElementTypes.GeneratorProduce_4027);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSourceAndTarget(IAdaptable source,
			IAdaptable target) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof ModelEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof MMEditPart) {
				types.add(CallchainElementTypes.ModelMm_4018);
			}
			return types;
		}
		if (sourceEditPart instanceof AtlResEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof AtlResEditPart) {
				types.add(CallchainElementTypes.AtlResSuperimpose_4019);
			}
			return types;
		}
		if (sourceEditPart instanceof CallEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof ModelEditPart) {
				types.add(CallchainElementTypes.ModelAlias_4016);
			}
			if (targetEditPart instanceof ModelEditPart) {
				types.add(CallchainElementTypes.CallIn_4020);
			}
			if (targetEditPart instanceof ModelEditPart) {
				types.add(CallchainElementTypes.CallOut_4021);
			}
			if (targetEditPart instanceof AtlResEditPart) {
				types.add(CallchainElementTypes.CallRes_4022);
			}
			if (targetEditPart instanceof AtlLibaryEditPart) {
				types.add(CallchainElementTypes.CallLibarys_4023);
			}
			if (targetEditPart instanceof ArtifactEditPart) {
				types.add(CallchainElementTypes.CallArtifact_4024);
			}
			return types;
		}
		if (sourceEditPart instanceof CommentEditPart) {
			List types = new ArrayList();
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated not
	 */
	public List getTypesForSource(IAdaptable target,
			IElementType relationshipType) {
		return getTypesForSource_intern(target, relationshipType);

		//		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
		//				.getAdapter(IGraphicalEditPart.class);
		//		if (targetEditPart instanceof ModelEditPart) {
		//			List types = new ArrayList();
		//			if (relationshipType == CallchainElementTypes.ModelAlias_4016) {
		//				types.add(CallchainElementTypes.Call_2017);
		//			}
		//			if (relationshipType == CallchainElementTypes.CallIn_4020) {
		//				types.add(CallchainElementTypes.Call_2017);
		//			}
		//			if (relationshipType == CallchainElementTypes.CallOut_4021) {
		//				types.add(CallchainElementTypes.Call_2017);
		//			}
		//			return types;
		//		}
		//		if (targetEditPart instanceof AtlResEditPart) {
		//			List types = new ArrayList();
		//			if (relationshipType == CallchainElementTypes.AtlResSuperimpose_4019) {
		//				types.add(CallchainElementTypes.AtlRes_2016);
		//			}
		//			if (relationshipType == CallchainElementTypes.CallRes_4022) {
		//				types.add(CallchainElementTypes.Call_2017);
		//			}
		//			return types;
		//		}
		//		if (targetEditPart instanceof MMEditPart) {
		//			List types = new ArrayList();
		//			if (relationshipType == CallchainElementTypes.ModelMm_4018) {
		//				types.add(CallchainElementTypes.Model_2015);
		//			}
		//			return types;
		//		}
		//		if (targetEditPart instanceof AtlLibaryEditPart) {
		//			List types = new ArrayList();
		//			if (relationshipType == CallchainElementTypes.CallLibarys_4023) {
		//				types.add(CallchainElementTypes.Call_2017);
		//			}
		//			return types;
		//		}
		//		if (targetEditPart instanceof ArtifactEditPart) {
		//			List types = new ArrayList();
		//			if (relationshipType == CallchainElementTypes.CallArtifact_4024) {
		//				types.add(CallchainElementTypes.Call_2017);
		//			}
		//			return types;
		//		}
		//		return Collections.EMPTY_LIST;
	}

	private List getTypesForSource_intern(IAdaptable target,
			IElementType relationshipType) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof ModelEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.ModelAlias_4016) {
				types.add(CallchainElementTypes.Call_2017);
			}
			if (relationshipType == CallchainElementTypes.CallIn_4020) {
				types.add(CallchainElementTypes.Call_2017);
			}
			if (relationshipType == CallchainElementTypes.CallOut_4021) {
				types.add(CallchainElementTypes.Call_2017);
			}
			return types;
		}
		if (targetEditPart instanceof AtlResEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.AtlResSuperimpose_4019) {
				types.add(CallchainElementTypes.AtlRes_2016);
			}
			if (relationshipType == CallchainElementTypes.CallRes_4022) {
				types.add(CallchainElementTypes.Call_2017);
			}
			return types;
		}
		if (targetEditPart instanceof MMEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.ModelMm_4018) {
				types.add(CallchainElementTypes.Model_2015);
			}
			return types;
		}
		if (targetEditPart instanceof AtlLibaryEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.CallLibarys_4023) {
				types.add(CallchainElementTypes.Call_2017);
			}
			return types;
		}
		if (targetEditPart instanceof ArtifactEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.CallArtifact_4024) {
				types.add(CallchainElementTypes.Call_2017);
			}
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated not
	 */
	public List getTypesForTarget(IAdaptable source,
			IElementType relationshipType) {
		return getTypesForTarget_intern(source, relationshipType);
	}

	private List getTypesForTarget_intern(IAdaptable source,
			IElementType relationshipType) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof ModelEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.ModelMm_4018) {
				types.add(CallchainElementTypes.MM_2018);
			}
			return types;
		}
		if (sourceEditPart instanceof AtlResEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.AtlResSuperimpose_4019) {
				types.add(CallchainElementTypes.AtlRes_2016);
			}
			return types;
		}
		if (sourceEditPart instanceof CallEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.ModelAlias_4016) {
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.CallIn_4020) {
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.CallOut_4021) {
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.CallRes_4022) {
				types.add(CallchainElementTypes.AtlRes_2016);
			}
			if (relationshipType == CallchainElementTypes.CallLibarys_4023) {
				types.add(CallchainElementTypes.AtlLibary_2019);
			}
			if (relationshipType == CallchainElementTypes.CallArtifact_4024) {
				types.add(CallchainElementTypes.MM_2018);
				types.add(CallchainElementTypes.Model_2015);
				types.add(CallchainElementTypes.Artifact_2020);
			}
			return types;
		}
		if (sourceEditPart instanceof AM3_GeneratorEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			return types;
		}
		if (sourceEditPart instanceof GMF_GeneratorEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			return types;
		}
		if (sourceEditPart instanceof EMF_GeneratorEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			return types;
		}
		if (sourceEditPart instanceof Useit_GeneratorEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			return types;
		}
		if (sourceEditPart instanceof TopcasedGeneratorEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			return types;
		}

		if (sourceEditPart instanceof CommentEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.MM_2018);
			types.add(CallchainElementTypes.Model_2015);
			types.add(CallchainElementTypes.AtlLibary_2019);
			types.add(CallchainElementTypes.AtlRes_2016);
			types.add(CallchainElementTypes.Artifact_2020);

			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForSource(IAdaptable target,
			IElementType relationshipType) {
		return selectExistingElement(target, getTypesForSource(target,
				relationshipType));
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForTarget(IAdaptable source,
			IElementType relationshipType) {
		return selectExistingElement(source, getTypesForTarget(source,
				relationshipType));
	}

	/**
	 * @generated
	 */
	protected EObject selectExistingElement(IAdaptable host, Collection types) {
		if (types.isEmpty()) {
			return null;
		}
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart == null) {
			return null;
		}
		Diagram diagram = (Diagram) editPart.getRoot().getContents().getModel();
		Collection elements = new HashSet();
		for (Iterator it = diagram.getElement().eAllContents(); it.hasNext();) {
			EObject element = (EObject) it.next();
			if (isApplicableElement(element, types)) {
				elements.add(element);
			}
		}
		if (elements.isEmpty()) {
			return null;
		}
		return selectElement((EObject[]) elements.toArray(new EObject[elements
				.size()]));
	}

	/**
	 * @generated
	 */
	protected boolean isApplicableElement(EObject element, Collection types) {
		IElementType type = ElementTypeRegistry.getInstance().getElementType(
				element);
		return types.contains(type);
	}

	/**
	 * @generated
	 */
	protected EObject selectElement(EObject[] elements) {
		Shell shell = Display.getCurrent().getActiveShell();
		ILabelProvider labelProvider = new AdapterFactoryLabelProvider(
				CallchainDiagramEditorPlugin.getInstance()
						.getItemProvidersAdapterFactory());
		ElementListSelectionDialog dialog = new ElementListSelectionDialog(
				shell, labelProvider);
		dialog.setMessage(Messages.CallchainModelingAssistantProviderMessage);
		dialog.setTitle(Messages.CallchainModelingAssistantProviderTitle);
		dialog.setMultipleSelection(false);
		dialog.setElements(elements);
		EObject selected = null;
		if (dialog.open() == Window.OK) {
			selected = (EObject) dialog.getFirstResult();
		}
		return selected;
	}
}
