package de.urszeidler.eclipse.callchain.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.diagram.core.providers.AbstractViewProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.type.core.IHintedType;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResSuperimposeEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallInEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallLibarysEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallOutEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallableNextEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallsEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocumentedElementEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorProduceEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorUsesEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMHandlerEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelMmEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Useit_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Useit_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.diagram.view.factories.AM3_GeneratorKindViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.AM3_GeneratorNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.AM3_GeneratorViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.ArtifactNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.ArtifactUriViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.ArtifactViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.AtlLibaryNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.AtlLibaryUriViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.AtlLibaryViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.AtlResNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.AtlResSuperimposeViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.AtlResUriViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.AtlResViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CallArtifactViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CallInViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CallLibarysViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CallNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CallOutViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CallResViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CallViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CallableNextViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CallsViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CommentDocViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CommentDocumentedElementViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.CommentViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.EMF_GeneratorKindViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.EMF_GeneratorNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.EMF_GeneratorViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.GMF_GeneratorKindViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.GMF_GeneratorNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.GMF_GeneratorViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.GeneratorProduceViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.GeneratorUsesViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.Generic_GeneratorNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.Generic_GeneratorViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.MMAliasAliasNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.MMAliasViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.MMHandlerViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.MMNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.MMUriViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.MMViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.ModelAliasAliasNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.ModelAliasViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.ModelMmViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.ModelNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.ModelUriViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.ModelViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.TopcasedGeneratorKindViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.TopcasedGeneratorNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.TopcasedGeneratorViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.Useit_GeneratorNameViewFactory;
import de.urszeidler.eclipse.callchain.diagram.view.factories.Useit_GeneratorViewFactory;

/**
 * @generated
 */
public class CallchainViewProvider extends AbstractViewProvider {

	/**
	 * @generated
	 */
	protected Class getDiagramViewClass(IAdaptable semanticAdapter,
			String diagramKind) {
		EObject semanticElement = getSemanticElement(semanticAdapter);
		if (CallsEditPart.MODEL_ID.equals(diagramKind)
				&& CallchainVisualIDRegistry
						.getDiagramVisualID(semanticElement) != -1) {
			return CallsViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		if (containerView == null) {
			return null;
		}
		IElementType elementType = getSemanticElementType(semanticAdapter);
		EObject domainElement = getSemanticElement(semanticAdapter);
		int visualID;
		if (semanticHint == null) {
			// Semantic hint is not specified. Can be a result of call from CanonicalEditPolicy.
			// In this situation there should be NO elementType, visualID will be determined
			// by VisualIDRegistry.getNodeVisualID() for domainElement.
			if (elementType != null || domainElement == null) {
				return null;
			}
			visualID = CallchainVisualIDRegistry.getNodeVisualID(containerView,
					domainElement);
		} else {
			visualID = CallchainVisualIDRegistry.getVisualID(semanticHint);
			if (elementType != null) {
				// Semantic hint is specified together with element type.
				// Both parameters should describe exactly the same diagram element.
				// In addition we check that visualID returned by VisualIDRegistry.getNodeVisualID() for
				// domainElement (if specified) is the same as in element type.
				if (!CallchainElementTypes.isKnownElementType(elementType)
						|| (!(elementType instanceof IHintedType))) {
					return null; // foreign element type
				}
				String elementTypeHint = ((IHintedType) elementType)
						.getSemanticHint();
				if (!semanticHint.equals(elementTypeHint)) {
					return null; // if semantic hint is specified it should be the same as in element type
				}
				if (domainElement != null
						&& visualID != CallchainVisualIDRegistry
								.getNodeVisualID(containerView, domainElement)) {
					return null; // visual id for node EClass should match visual id from element type
				}
			} else {
				// Element type is not specified. Domain element should be present (except pure design elements).
				// This method is called with EObjectAdapter as parameter from:
				//   - ViewService.createNode(View container, EObject eObject, String type, PreferencesHint preferencesHint) 
				//   - generated ViewFactory.decorateView() for parent element
				if (!CallsEditPart.MODEL_ID.equals(CallchainVisualIDRegistry
						.getModelID(containerView))) {
					return null; // foreign diagram
				}
				switch (visualID) {
				case ModelEditPart.VISUAL_ID:
				case AtlResEditPart.VISUAL_ID:
				case CallEditPart.VISUAL_ID:
				case MMEditPart.VISUAL_ID:
				case AtlLibaryEditPart.VISUAL_ID:
				case ArtifactEditPart.VISUAL_ID:
				case EMF_GeneratorEditPart.VISUAL_ID:
				case Useit_GeneratorEditPart.VISUAL_ID:
				case TopcasedGeneratorEditPart.VISUAL_ID:
				case CommentEditPart.VISUAL_ID:
				case AM3_GeneratorEditPart.VISUAL_ID:
				case GMF_GeneratorEditPart.VISUAL_ID:
				case Generic_GeneratorEditPart.VISUAL_ID:
					if (domainElement == null
							|| visualID != CallchainVisualIDRegistry
									.getNodeVisualID(containerView,
											domainElement)) {
						return null; // visual id in semantic hint should match visual id for domain element
					}
					break;
				case ModelUriEditPart.VISUAL_ID:
				case ModelNameEditPart.VISUAL_ID:
					if (ModelEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case AtlResUriEditPart.VISUAL_ID:
				case AtlResNameEditPart.VISUAL_ID:
					if (AtlResEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case CallNameEditPart.VISUAL_ID:
					if (CallEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case MMHandlerEditPart.VISUAL_ID:
				case MMUriEditPart.VISUAL_ID:
				case MMNameEditPart.VISUAL_ID:
					if (MMEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case AtlLibaryUriEditPart.VISUAL_ID:
				case AtlLibaryNameEditPart.VISUAL_ID:
					if (AtlLibaryEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case ArtifactNameEditPart.VISUAL_ID:
				case ArtifactUriEditPart.VISUAL_ID:
					if (ArtifactEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case EMF_GeneratorKindEditPart.VISUAL_ID:
				case EMF_GeneratorNameEditPart.VISUAL_ID:
					if (EMF_GeneratorEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case Useit_GeneratorNameEditPart.VISUAL_ID:
					if (Useit_GeneratorEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case TopcasedGeneratorKindEditPart.VISUAL_ID:
				case TopcasedGeneratorNameEditPart.VISUAL_ID:
					if (TopcasedGeneratorEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case CommentDocEditPart.VISUAL_ID:
					if (CommentEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case AM3_GeneratorKindEditPart.VISUAL_ID:
				case AM3_GeneratorNameEditPart.VISUAL_ID:
					if (AM3_GeneratorEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case GMF_GeneratorKindEditPart.VISUAL_ID:
				case GMF_GeneratorNameEditPart.VISUAL_ID:
					if (GMF_GeneratorEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case Generic_GeneratorNameEditPart.VISUAL_ID:
					if (Generic_GeneratorEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case ModelAliasAliasNameEditPart.VISUAL_ID:
					if (ModelAliasEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case MMAliasAliasNameEditPart.VISUAL_ID:
					if (MMAliasEditPart.VISUAL_ID != CallchainVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				default:
					return null;
				}
			}
		}
		return getNodeViewClass(containerView, visualID);
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(View containerView, int visualID) {
		if (containerView == null
				|| !CallchainVisualIDRegistry.canCreateNode(containerView,
						visualID)) {
			return null;
		}
		switch (visualID) {
		case ModelEditPart.VISUAL_ID:
			return ModelViewFactory.class;
		case ModelUriEditPart.VISUAL_ID:
			return ModelUriViewFactory.class;
		case ModelNameEditPart.VISUAL_ID:
			return ModelNameViewFactory.class;
		case AtlResEditPart.VISUAL_ID:
			return AtlResViewFactory.class;
		case AtlResUriEditPart.VISUAL_ID:
			return AtlResUriViewFactory.class;
		case AtlResNameEditPart.VISUAL_ID:
			return AtlResNameViewFactory.class;
		case CallEditPart.VISUAL_ID:
			return CallViewFactory.class;
		case CallNameEditPart.VISUAL_ID:
			return CallNameViewFactory.class;
		case MMEditPart.VISUAL_ID:
			return MMViewFactory.class;
		case MMHandlerEditPart.VISUAL_ID:
			return MMHandlerViewFactory.class;
		case MMUriEditPart.VISUAL_ID:
			return MMUriViewFactory.class;
		case MMNameEditPart.VISUAL_ID:
			return MMNameViewFactory.class;
		case AtlLibaryEditPart.VISUAL_ID:
			return AtlLibaryViewFactory.class;
		case AtlLibaryUriEditPart.VISUAL_ID:
			return AtlLibaryUriViewFactory.class;
		case AtlLibaryNameEditPart.VISUAL_ID:
			return AtlLibaryNameViewFactory.class;
		case ArtifactEditPart.VISUAL_ID:
			return ArtifactViewFactory.class;
		case ArtifactNameEditPart.VISUAL_ID:
			return ArtifactNameViewFactory.class;
		case ArtifactUriEditPart.VISUAL_ID:
			return ArtifactUriViewFactory.class;
		case EMF_GeneratorEditPart.VISUAL_ID:
			return EMF_GeneratorViewFactory.class;
		case EMF_GeneratorKindEditPart.VISUAL_ID:
			return EMF_GeneratorKindViewFactory.class;
		case EMF_GeneratorNameEditPart.VISUAL_ID:
			return EMF_GeneratorNameViewFactory.class;
		case Useit_GeneratorEditPart.VISUAL_ID:
			return Useit_GeneratorViewFactory.class;
		case Useit_GeneratorNameEditPart.VISUAL_ID:
			return Useit_GeneratorNameViewFactory.class;
		case TopcasedGeneratorEditPart.VISUAL_ID:
			return TopcasedGeneratorViewFactory.class;
		case TopcasedGeneratorKindEditPart.VISUAL_ID:
			return TopcasedGeneratorKindViewFactory.class;
		case TopcasedGeneratorNameEditPart.VISUAL_ID:
			return TopcasedGeneratorNameViewFactory.class;
		case CommentEditPart.VISUAL_ID:
			return CommentViewFactory.class;
		case CommentDocEditPart.VISUAL_ID:
			return CommentDocViewFactory.class;
		case AM3_GeneratorEditPart.VISUAL_ID:
			return AM3_GeneratorViewFactory.class;
		case AM3_GeneratorKindEditPart.VISUAL_ID:
			return AM3_GeneratorKindViewFactory.class;
		case AM3_GeneratorNameEditPart.VISUAL_ID:
			return AM3_GeneratorNameViewFactory.class;
		case GMF_GeneratorEditPart.VISUAL_ID:
			return GMF_GeneratorViewFactory.class;
		case GMF_GeneratorKindEditPart.VISUAL_ID:
			return GMF_GeneratorKindViewFactory.class;
		case GMF_GeneratorNameEditPart.VISUAL_ID:
			return GMF_GeneratorNameViewFactory.class;
		case Generic_GeneratorEditPart.VISUAL_ID:
			return Generic_GeneratorViewFactory.class;
		case Generic_GeneratorNameEditPart.VISUAL_ID:
			return Generic_GeneratorNameViewFactory.class;
		case ModelAliasAliasNameEditPart.VISUAL_ID:
			return ModelAliasAliasNameViewFactory.class;
		case MMAliasAliasNameEditPart.VISUAL_ID:
			return MMAliasAliasNameViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		IElementType elementType = getSemanticElementType(semanticAdapter);
		if (!CallchainElementTypes.isKnownElementType(elementType)
				|| (!(elementType instanceof IHintedType))) {
			return null; // foreign element type
		}
		String elementTypeHint = ((IHintedType) elementType).getSemanticHint();
		if (elementTypeHint == null) {
			return null; // our hint is visual id and must be specified
		}
		if (semanticHint != null && !semanticHint.equals(elementTypeHint)) {
			return null; // if semantic hint is specified it should be the same as in element type
		}
		int visualID = CallchainVisualIDRegistry.getVisualID(elementTypeHint);
		EObject domainElement = getSemanticElement(semanticAdapter);
		if (domainElement != null
				&& visualID != CallchainVisualIDRegistry
						.getLinkWithClassVisualID(domainElement)) {
			return null; // visual id for link EClass should match visual id from element type
		}
		return getEdgeViewClass(visualID);
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(int visualID) {
		switch (visualID) {
		case ModelAliasEditPart.VISUAL_ID:
			return ModelAliasViewFactory.class;
		case MMAliasEditPart.VISUAL_ID:
			return MMAliasViewFactory.class;
		case ModelMmEditPart.VISUAL_ID:
			return ModelMmViewFactory.class;
		case AtlResSuperimposeEditPart.VISUAL_ID:
			return AtlResSuperimposeViewFactory.class;
		case CallInEditPart.VISUAL_ID:
			return CallInViewFactory.class;
		case CallOutEditPart.VISUAL_ID:
			return CallOutViewFactory.class;
		case CallResEditPart.VISUAL_ID:
			return CallResViewFactory.class;
		case CallLibarysEditPart.VISUAL_ID:
			return CallLibarysViewFactory.class;
		case CallArtifactEditPart.VISUAL_ID:
			return CallArtifactViewFactory.class;
		case CommentDocumentedElementEditPart.VISUAL_ID:
			return CommentDocumentedElementViewFactory.class;
		case GeneratorUsesEditPart.VISUAL_ID:
			return GeneratorUsesViewFactory.class;
		case GeneratorProduceEditPart.VISUAL_ID:
			return GeneratorProduceViewFactory.class;
		case CallableNextEditPart.VISUAL_ID:
			return CallableNextViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	private IElementType getSemanticElementType(IAdaptable semanticAdapter) {
		if (semanticAdapter == null) {
			return null;
		}
		return (IElementType) semanticAdapter.getAdapter(IElementType.class);
	}
}
