package de.urszeidler.eclipse.callchain.tabbedpropery.sections;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.jface.window.Window;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.dialogs.ElementTreeSelectionDialog;
import org.eclipse.ui.dialogs.ISelectionStatusValidator;
import org.eclipse.ui.model.WorkbenchContentProvider;
import org.eclipse.ui.model.WorkbenchLabelProvider;

import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.tabbedpropery.basicsections.AbstractTextButtonSection;

/**
 * A section display a text field to edit/see String features
 * 
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated not
 */
public class ArtifactUriSection extends AbstractTextButtonSection {

    protected void handleButtonPressed() {
        ElementTreeSelectionDialog elementTreeSelectionDialog = new ElementTreeSelectionDialog(
                PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),
                new WorkbenchLabelProvider(), new WorkbenchContentProvider());
        elementTreeSelectionDialog.setInput(ResourcesPlugin.getWorkspace()
                .getRoot());
        elementTreeSelectionDialog.setAllowMultiple(false);
        elementTreeSelectionDialog.setDoubleClickSelects(true);

        elementTreeSelectionDialog
                .setValidator(new ISelectionStatusValidator() {
                    public IStatus validate(Object[] selection) {
                        IStatus ret = Status.CANCEL_STATUS;

                        if (selection.length == 1) {
                            if (getEObject() instanceof AtlRes)
                                if (!(selection[0] instanceof IFile)) {
                                    return Status.CANCEL_STATUS;
                                    // ret = Status.OK_STATUS;
                                }
                            return Status.CANCEL_STATUS;
                        }

                        return ret;
                    }
                });

        int i = elementTreeSelectionDialog.open();
        Object result = elementTreeSelectionDialog.getFirstResult();
        if (i == Window.OK) {
            if ((result != null) && (result instanceof IFile)) {
                // TableItem item = table.getItem(index);
                IFile currentFile = (IFile) result;
                getText().setText(currentFile.getFullPath().toString());
            }

        }

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getLabelText()
     * @generated
     */
    protected String getLabelText() {
        return "Uri:";
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getFeature()
     * @generated
     */
    protected EStructuralFeature getFeature() {
        return CallchainPackage.eINSTANCE.getArtifact_Uri();
    }

}