/**
 * 
 */
package de.urszeidler.eclipse.callchain.ui.emf.actions;

import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.dialogs.ProgressMonitorDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.WorkspaceModifyOperation;

import de.urszeidler.eclipse.callchain.AM3_Generator;
import de.urszeidler.eclipse.callchain.EMF_Generator;
import de.urszeidler.eclipse.callchain.GMF_Generator;
import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.TopcasedGenerator;
import de.urszeidler.eclipse.callchain.executors.GMF_GeneratorExe;
import de.urszeidler.eclipse.callchain.executors.TopcasedGeneratorExe;
import de.urszeidler.eclipse.callchain.provider.CallchainEditPlugin;
import de.urszeidler.eclipse.callchain.util.CallchainSwitch;

/**
 * a switch deciding which gegeratorExecutor should be usesd
 * @author urs
 *
 */
final public class CallchainDoGenerationSwitch extends
		CallchainSwitch<Object> {
	private IProgressMonitor monitor;

	@Override
	public Object caseAM3_Generator(AM3_Generator object) {
		// TODO Auto-generated method stub
		return super.caseAM3_Generator(object);
	}

	@Override
	public Object caseEMF_Generator(EMF_Generator object) {
		return super.caseEMF_Generator(object);
	}

	@Override
	public Object caseGMF_Generator(GMF_Generator object) {
		GMF_GeneratorExe generatorExe = new GMF_GeneratorExe(object);
		generatorExe.generate(monitor);

		return null;
	}
	
	@Override
	public Object caseTopcasedGenerator(final TopcasedGenerator object) {
		
		
		WorkspaceModifyOperation op = new WorkspaceModifyOperation() {
          public void execute(IProgressMonitor monitor) throws CoreException,
                  InvocationTargetException, InterruptedException {
          	
              monitor.beginTask("Editor Generation process", 11);
              try {
                  try {
                      Generator gen = object;
                      
                       TopcasedGeneratorExe generatorExe = new TopcasedGeneratorExe(object);
                      generatorExe.generate(monitor);
        
                  } finally {
                     monitor.done();
                  }
              } catch (Exception ioe) {
                  IStatus status = new Status(IStatus.ERROR, "", IStatus.OK,
                          "Operation failed.", ioe);
                  throw new CoreException(status);
              }
          }
      };

      IWorkbench workBench = PlatformUI.getWorkbench();

      try {
          Shell shell = workBench.getActiveWorkbenchWindow().getShell();
          ProgressMonitorDialog dialog = new ProgressMonitorDialog(shell);
          try {
              dialog.run(true, false, op);
           } finally {
              dialog.close();
          }// end of try catch
      } catch (Exception e) {
          CallchainEditPlugin.log("error while generating", IStatus.ERROR, e);
       }

		return super.caseTopcasedGenerator(object);
	}
	
	@Override
	public Object caseGenerator(Generator object) {
		//startGenerator(object);
		return super.caseGenerator(object);
	}

	public void setMonitor(IProgressMonitor pmon) {
		this.monitor = pmon;
		
	}
}